﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

// See http://en.wikipedia.org/wiki/Fuel_efficiency

namespace howto_mileage_consumption
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        // Conversion factors.
        private const float miles_per_km = 0.621371192f;
        private const float us_gallons_per_liter = 0.264172052637296f;
        private const float uk_gallons_per_liter = 0.2199692483f;

        // Calculate the mileage statistics.
        private void btnCalculate_Click(object sender, EventArgs e)
        {
            // Get the inputs.
            float miles = float.Parse(txtDistance.Text);
            float gallons = float.Parse(txtFuel.Text);

            // Convert to miles and US gallons.
            if (radKilometers.Checked) miles *= miles_per_km;
            if (radUkGallons.Checked)
            {
                gallons *= us_gallons_per_liter / uk_gallons_per_liter;
            }
            else if (radKilometers.Checked)
            {
                gallons *= us_gallons_per_liter;
            }

            // Calculate performance values.
            float us_mpg = miles / gallons;
            float us_gal_per_100_miles = 100 / us_mpg;

            // US values.
            txtUsMpg.Text = us_mpg.ToString("0.00");
            txtUsGalPer100Miles.Text = us_gal_per_100_miles.ToString("0.00");

            // UK values.
            float uk_gals = gallons * uk_gallons_per_liter / us_gallons_per_liter;
            float uk_mpg = miles / uk_gals;
            float uk_gal_per_100_miles = 100 / uk_mpg;
            txtUkMpg.Text = uk_mpg.ToString("0.00");
            txtUkGalPer100Miles.Text = uk_gal_per_100_miles.ToString("0.00");

            // Metric values.
            float liters = gallons / us_gallons_per_liter;
            float kilometers = miles / miles_per_km;
            float km_per_liter = kilometers / liters;
            float l_per_100_km = 100 / km_per_liter;
            txtKpl.Text = km_per_liter.ToString("0.00");
            txtLiterPer100km.Text = l_per_100_km.ToString("0.00");
        }
    }
}
